/* init.c -
 *
 * Copyright (C) 2002  Jochen Voss.  */

static const  char  rcsid[] = "$Id: vinit.c,v 1.1.1.1 2002/10/13 11:10:08 voss Exp $";

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "rndlib.h"


char **orig_argv;
int  orig_argc;
char **xargv;
int  xargc, xargv_len;

char *myname;
int  interactive_flag;

void
vinit (int argc, char **argv)
{
  interactive_flag = isatty (0);

  /* `basename' seems to be non-standard.  So we avoid it.  */
  myname = strrchr (argv[0], '/');
  myname = strdup (myname ? myname+1 : argv[0]);
  if (! myname)  fatal ("memory exhausted");
  
  xargc = orig_argc = argc;
  orig_argv = argv;
  xargv = xmalloc (argc*sizeof (char *));
  memcpy (xargv, argv, xargc*sizeof (char *));
}

void
vexit (void)
{
  vendopt ();
  free (xargv);
  free (myname);
}
